package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_MOTIVAZIONI_ALERT_PF")
public class DmotivazioniAlertPf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 1180740045L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DmotivazioniAlertPf.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_MOTIVAZIONE_ALERT_PF", columnDefinition = "NUMBER(15)")
	private Long sequIdMotivazioneAlertPf;
	@NotNull

	@Column(name = "CODI_MOTIVAZIONE_ALERT", columnDefinition = "VARCHAR(50)")
	private String codiMotivazioneAlert;
	@NotNull

	@Column(name = "DESC_MOTIVAZIONE_ALERT", columnDefinition = "VARCHAR(250)")
	private String descMotivazioneAlert;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DmotivazioniAlertPf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DmotivazioniAlertPf(DmotivazioniAlertPfKey dmotivazioniAlertPfKey, Long sequIdMotivazioneAlertPf,
			String codiMotivazioneAlert, String descMotivazioneAlert, Date dataUltimaModifica, String flagEliminato,
			Date dataFineRecord, String utenteUltimaModifica, Date dataInizioRecord) {
		super();

		this.dmotivazioniAlertPfKey = dmotivazioniAlertPfKey;

		this.sequIdMotivazioneAlertPf = sequIdMotivazioneAlertPf;
		this.codiMotivazioneAlert = codiMotivazioneAlert;
		this.descMotivazioneAlert = descMotivazioneAlert;
		this.dataUltimaModifica = dataUltimaModifica;
		this.flagEliminato = flagEliminato;
		this.dataFineRecord = dataFineRecord;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDmotivazioniAlertPf")
	@OneToMany(mappedBy = "theDmotivazioniAlertPf", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DammtiPianiFerie> theDammtiPianiFerie = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdMotivazioneAlertPf
	 */
	public Long getSequIdMotivazioneAlertPf() {
		return this.sequIdMotivazioneAlertPf;
	}

	/**
	 * @param sequIdMotivazioneAlertPf to set
	 */
	public void setSequIdMotivazioneAlertPf(Long sequIdMotivazioneAlertPf) {
		this.sequIdMotivazioneAlertPf = sequIdMotivazioneAlertPf;
	}

	/**
	 * @return the codiMotivazioneAlert
	 */
	public String getCodiMotivazioneAlert() {
		return this.codiMotivazioneAlert;
	}

	/**
	 * @param codiMotivazioneAlert to set
	 */
	public void setCodiMotivazioneAlert(String codiMotivazioneAlert) {
		this.codiMotivazioneAlert = codiMotivazioneAlert;
	}

	/**
	 * @return the descMotivazioneAlert
	 */
	public String getDescMotivazioneAlert() {
		return this.descMotivazioneAlert;
	}

	/**
	 * @param descMotivazioneAlert to set
	 */
	public void setDescMotivazioneAlert(String descMotivazioneAlert) {
		this.descMotivazioneAlert = descMotivazioneAlert;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DammtiPianiFerie
	 */
	public Collection<DammtiPianiFerie> getTheDammtiPianiFerie() {
		return theDammtiPianiFerie;
	}

	/**
	 * @param aDammtiPianiFerieList to set
	 */
	public void setTheDammtiPianiFerie(Collection<DammtiPianiFerie> aDammtiPianiFerieList) {
		theDammtiPianiFerie = aDammtiPianiFerieList;
	}

	/// ADD CHILD
	public void addDammtiPianiFerie(DammtiPianiFerie dammtiPianiFerie) {
		theDammtiPianiFerie.add(dammtiPianiFerie);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDmotivazioniAlertPfKey());
	}

	public String getObjectKeyById(DmotivazioniAlertPfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dmotivazioniAlertPfKey = new DmotivazioniAlertPfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiMotivazioneAlert());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DmotivazioniAlertPfKey dmotivazioniAlertPfKey;

	// GETTER/SETTER CK
	/**
	 * @return the dmotivazioniAlertPfKey
	 */
	public DmotivazioniAlertPfKey getDmotivazioniAlertPfKey() {
		return this.dmotivazioniAlertPfKey;
	}

	/**
	 * @param dmotivazioniAlertPfKey to set
	 */
	public void setDmotivazioniAlertPfKey(DmotivazioniAlertPfKey dmotivazioniAlertPfKey) {
		this.dmotivazioniAlertPfKey = dmotivazioniAlertPfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dmotivazioniAlertPfKey == null) {
			dmotivazioniAlertPfKey = new DmotivazioniAlertPfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DmotivazioniAlertPf that = (DmotivazioniAlertPf) o;
		return dmotivazioniAlertPfKey != null && Objects.equals(dmotivazioniAlertPfKey, that.dmotivazioniAlertPfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dmotivazioniAlertPfKey);
	}
}
